<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card display-flex">
                    <form action="#" @submit.prevent="submit">
                        <div class="card-header">Create appointment</div>

                        <div class="card-body">
                            <div class="alert alert-danger" role="alert" v-if="error">
                                {{ error }}
                            </div>

                            <div class="form-group row">
                                <label for="doctor" class="col-md-4 col-form-label text-md-right">Doctor</label>

                                <v-select id="doctor"
                                          v-model="doctor"
                                          :filterable="false"
                                          :options="doctors"
                                          @search="fetchDoctors">
                                    <template slot="no-options">
                                        type 3 letters to search...
                                    </template>
                                    <template v-slot:option="doctor">
                                        <div v-html="doctor.name"></div>
                                    </template>
                                    <template v-slot:selected-option="doctor">
                                        <div v-html="doctor.name"></div>
                                    </template>
                                </v-select>
                            </div>

                            <div class="form-group row" v-if="doctor">
                                <label for="user" class="col-md-4 col-form-label text-md-right">Patient</label>

                                <v-select id="user"
                                          v-model="user"
                                          :filterable="false"
                                          :options="users"
                                          @search="fetchUsers">
                                    <template slot="no-options">
                                        type 3 letters to search...
                                    </template>
                                    <template v-slot:option="user">
                                        <div v-html="user.name"></div>
                                    </template>
                                    <template v-slot:selected-option="user">
                                        <div v-html="user.name"></div>
                                    </template>
                                </v-select>
                            </div>

                            <div class="form-group row" v-if="user">
                                <label for="description" class="col-md-4 col-form-label text-md-right">Description</label>

                                <div class="col-md-6">
                                    <input id="description" type="text" class="form-control" name="text" v-model="description">
                                </div>
                            </div>

                            <div class="form-group row" v-if="doctor && user && description">
                                <label for="date" class="col-md-4 col-form-label text-md-right">Date and time</label>

                                <date-picker id="date"
                                             v-model="date"
                                             type="datetime"
                                             :show-second="dateTimePicker.showSecond"
                                             :time-picker-options="dateTimePicker.options"
                                             :disabled-time="disabledTime"
                                             :disabled-date="disabledDays"
                                             class="mg-l-15">
                                </date-picker>
                            </div>

                            <div class="form-group row mb-0">
                                <div class="col-md-8 offset-md-4">
                                    <button type="submit" class="btn btn-primary">
                                        Submit
                                    </button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';
import DatePicker from 'vue2-datepicker';
import VSelect from 'vue-select';
import 'vue2-datepicker/index.css';
import configs from './../../config'

export default {
    components: { DatePicker, VSelect },
    data() {
        return {
            appointments: [],
            doctors: [],
            users: [],
            disabledTimes: [],

            loading: null,
            error: null,

            dateTimePicker: {
                showSecond: false,
                options: {
                    start: '08:00',
                    step: '00:30',
                    end: '16:30',
                    format: 'HH:mm'
                },
            },

            doctor: null,
            user: null,
            date: null,
            description: null
        };
    },

    beforeMount() {
        window.addEventListener("beforeunload", this.cancelReserveTime);
    },

    mounted() {
        this.fetchAppointments();
    },

    methods: {
        fetchAppointments() {
            this.loading = true;
            axios
                .get(configs.APPOINTMENT_URL + '/taken')
                .then(response => {
                    this.loading = false;
                    this.appointments = response.data;
                })
                .catch(error => {
                    this.loading = false;
                    this.error = error.response.data.message || error.message;
                });
        },

        fetchDisabledTimes(id) {
            this.loading = true;
            axios
                .get(configs.APPOINTMENT_URL + `/taken/${id}`)
                .then(response => {
                    this.loading = false;
                    this.disabledTimes = Object.values(response.data);
                })
                .catch(error => {
                    this.loading = false;
                    this.error = error.response.data.message || error.message;
                });
        },

        fetchUsers(search) {
            if (search.length >= 3) {
                this.loading = true;
                axios
                    .get(configs.PATIENTS_URL + `/${search}`)
                    .then(response => {
                        this.loading = false;
                        this.users = response.data;
                    })
                    .catch(error => {
                        this.loading = false;
                        this.error = error.response.data.message || error.message;
                    });
            }
        },

        fetchDoctors(search) {
            if (search.length >= 3) {
                this.loading = true;
                axios
                    .get(configs.DOCTORS_URL + `/${search}`)
                    .then(response => {
                        this.loading = false;
                        this.doctors = response.data;
                    })
                    .catch(error => {
                        this.loading = false;
                        this.error = error.response.data.message || error.message;
                    });
            }
        },

        submit() {
            this.loading = true;
            let form = {
                doctor_id: this.doctor.id,
                user_id: this.user.id,
                date: this.convert(this.date),
                description: this.description
            }
            axios
                .put(configs.APPOINTMENT_URL, form)
                .then(response => {
                    window.location.href = configs.APPOINTMENT_URL;
                })
                .catch(error => {
                    this.loading = false;
                    this.error = error.response.data.message || error.message;
                });
        },

        cancelReserveTime(date = null) {
            this.loading = true;
            let form = {
                doctor_id: this.doctor.id,
                user_id: this.user.id,
                date: typeof date === 'string' ? date : this.convert(this.date),
                description: this.description
            }
            axios
                .put(configs.APPOINTMENT_CANCEL_RESERVE_URL, form)
                .then(response => {
                })
                .catch(error => {
                    this.loading = false;
                    this.error = error.response.data.message || error.message;
                });
        },

        reserveTime(date) {
            this.loading = true;
            let form = {
                doctor_id: this.doctor.id,
                user_id: this.user.id,
                date: date,
                description: this.description
            }
            axios
                .put(configs.APPOINTMENT_RESERVE_URL, form)
                .then(response => {
                })
                .catch(error => {
                    this.loading = false;
                    this.error = error.response.data.message || error.message;
                });
        },

        disabledDays(date) {
            return new Date(this.convert(date)) <= new Date();
        },

        disabledTime(date) {
            return this.disabledTimes.some(el => el.date.includes(this.convert(date))) ||
                new Date(this.convert(date)) <= new Date();
        },

        convert(dateString) {
            let date = new Date(dateString);
            let month = ("0" + (date.getMonth()+1)).slice(-2);
            let day  = ("0" + date.getDate()).slice(-2);
            let hours  = ("0" + date.getHours()).slice(-2);
            let minutes = ("0" + date.getMinutes()).slice(-2);

            let dateFormat = [date.getFullYear(), month, day].join("-");
            let timeFormat = [hours, minutes].join(":");

            return [dateFormat, timeFormat].join(" ");
        },
    },

    watch: {
        doctor: function(doctor) {
            if (doctor) {
                this.fetchDisabledTimes(doctor.id);
            }
        },
        date: function (date, oldDate) {
            if (date && !this.convert(date).includes('00:00')) {
                this.cancelReserveTime(this.convert(oldDate));
                this.reserveTime(this.convert(date));
            }
        }
    }
}
</script>
